---
title: Using the Geolocation API
slug: Web/API/Geolocation_API/Using_the_Geolocation_API
tags:
  - Geolocation API
  - Guide
  - Tutorial
---
<div>{{securecontext_header}}{{DefaultAPISidebar("Geolocation API")}}</div>

<p>The Geolocation API is used to retrieve the user's location, so that it can for example be used to display their position using a mapping API. This article explains the basics of how to use it.</p>

<h2 id="The_geolocation_object">The geolocation object</h2>

<p>The <a href="/en-US/docs/Web/API/Geolocation">Geolocation API</a> is available through the {{domxref("navigator.geolocation")}} object.</p>

<p>If the object exists, geolocation services are available. You can test for the presence of geolocation thusly:</p>

<pre class="brush: js notranslate">if('geolocation' in navigator) {
  /* geolocation is available */
} else {
  /* geolocation IS NOT available */
}
</pre>

<h3 id="Getting_the_current_position">Getting the current position</h3>

<p>To obtain the user's current location, you can call the {{domxref("Geolocation.getCurrentPosition","getCurrentPosition()")}} method. This initiates an asynchronous request to detect the user's position, and queries the positioning hardware to get up-to-date information. When the position is determined, the defined callback function is executed. You can optionally provide a second callback function to be executed if an error occurs. A third, optional, parameter is an options object where you can set the maximum age of the position returned, the time to wait for a request, and if you want high accuracy for the position.</p>

<div class="note">
<p><strong>Note:</strong> By default, {{domxref("Geolocation.getCurrentPosition","getCurrentPosition()")}} tries to answer as fast as possible with a low accuracy result. It is useful if you need a quick answer regardless of the accuracy. Devices with a GPS, for example, can take a minute or more to get a GPS fix, so less accurate data (IP location or wifi) may be returned to <code>getCurrentPosition()</code>.</p>
</div>

<pre class="brush: js notranslate">navigator.geolocation.getCurrentPosition((position) =&gt; {
  doSomething(position.coords.latitude, position.coords.longitude);
});</pre>

<p>The above example will cause the <code>doSomething()</code> function to execute when the location is obtained.</p>

<h3 id="Watching_the_current_position">Watching the current position</h3>

<p>If the position data changes (either by device movement or if more accurate geo information arrives), you can set up a callback function that is called with that updated position information. This is done using the {{domxref("Geolocation.watchPosition","watchPosition()")}} function, which has the same input parameters as {{domxref("Geolocation.getCurrentPosition","getCurrentPosition()")}}. The callback function is called multiple times, allowing the browser to either update your location as you move, or provide a more accurate location as different techniques are used to geolocate you. The error callback function, which is optional just as it is for <code>getCurrentPosition()</code>, can be called repeatedly.</p>

<div class="note">
<p><strong>Note:</strong> You can use {{domxref("Geolocation.watchPosition","watchPosition()")}} without an initial {{domxref("Geolocation.getCurrentPosition","getCurrentPosition()")}} call.</p>
</div>

<pre class="brush: js notranslate">const watchID = navigator.geolocation.watchPosition((position) =&gt; {
  doSomething(position.coords.latitude, position.coords.longitude);
});</pre>

<p>The {{domxref("Geolocation.watchPosition","watchPosition()")}} method returns an ID number that can be used to uniquely identify the requested position watcher; you use this value in tandem with the {{domxref("Geolocation.clearWatch","clearWatch()")}} method to stop watching the user's location.</p>

<pre class="brush: js notranslate">navigator.geolocation.clearWatch(watchID);
</pre>

<h3 id="Fine_tuning_the_response">Fine tuning the response</h3>

<p>Both {{domxref("Geolocation.getCurrentPosition","getCurrentPosition()")}} and {{domxref("Geolocation.watchPosition","watchPosition()")}} accept a success callback, an optional error callback, and an optional {{domxref("PositionOptions")}} object.</p>

<p>This object allows you to specify whether to enable high accuracy, a maximum age for the returned position value (up until this age it will be cached and reused if the same position is requested again; after this the browser will request fresh position data), and a timeout value that dictates how long the browser should attempt to get the position data for, before it times out.</p>

<p>A call to {{domxref("Geolocation.watchPosition","watchPosition")}} could look like:</p>

<pre class="brush: js notranslate">function success(position) {
  doSomething(position.coords.latitude, position.coords.longitude);
}

function error() {
  alert('Sorry, no position available.');
}

const options = {
  enableHighAccuracy: true,
  maximumAge: 30000,
  timeout: 27000
};

const watchID = navigator.geolocation.watchPosition(success, error, options);</pre>

<h2 id="Describing_a_position">Describing a position</h2>

<p>The user's location is described using a {{domxref("GeolocationPosition")}} object instance, which itself contains a {{domxref("GeolocationCoordinates")}} object instance.</p>

<p>The <code>GeolocationPosition</code> instance contains only two things, a <code>coords</code> property that contains the <code>GeolocationCoordinates</code> instance, and a <code>timestamp</code> property that contains a {{domxref("DOMTimeStamp")}} instance representing the time at which the position data was retrieved.</p>

<p>The <code>GeolocationCoordinates</code> instance contains a number of properties, but the two you'll use most commonly are <code>latitude</code> and <code>longitude</code>, which are what you need to draw your position on a map. Hence many Geolocation success callbacks look fairly simple:</p>

<pre class="brush: js notranslate">function success(position) {
  const latitude  = position.coords.latitude;
  const longitude = position.coords.longitude;

  // Do something with your latitude and longitude
}</pre>

<p>You can however get a number of other bits of information from a <code>GeolocationCoordinates</code> object, including altitude, speed, what direction the device is facing, and an accuracy measure of the altitude, longitude, and latitude data.</p>

<h2 id="Handling_errors">Handling errors</h2>

<p>The error callback function, if provided when calling <code>getCurrentPosition()</code> or <code>watchPosition()</code>, expects a <code><a href="/en-US/docs/Web/API/GeolocationPositionError">GeolocationPositionError</a></code> object instance as its first parameter. This object type contains two properties, a <code>code</code> indicating what type of error has been returned, and a human-readable <code>message</code> that describes what the error code means.</p>

<p>You could use it like so:</p>

<pre class="brush: js notranslate">function errorCallback(error) {
  alert(`ERROR(${error.code}): ${error.message}`);
};
</pre>

<h2 id="Examples">Examples</h2>

<p>In the following example the Geolocation API is used to retrieve the user's latitude and longitude. If sucessful, the available hyperlink is populated with an <code>openstreetmap.org</code> URL that will show their location.</p>

<div class="hidden">
<pre class="brush: css notranslate">body {
  padding: 20px;
  background-color:#ffffc9
}

button {
  margin: .5rem 0;
}
</pre>
</div>

<h3 id="HTML">HTML</h3>

<pre class="brush: html; notranslate">&lt;button id = "find-me"&gt;Show my location&lt;/button&gt;&lt;br/&gt;
&lt;p id = "status"&gt;&lt;/p&gt;
&lt;a id = "map-link" target="_blank"&gt;&lt;/a&gt;
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">function geoFindMe() {

  const status = document.querySelector('#status');
  const mapLink = document.querySelector('#map-link');

  mapLink.href = '';
  mapLink.textContent = '';

  function success(position) {
    const latitude  = position.coords.latitude;
    const longitude = position.coords.longitude;

    status.textContent = '';
    mapLink.href = `https://www.openstreetmap.org/#map=18/${latitude}/${longitude}`;
    mapLink.textContent = `Latitude: ${latitude} °, Longitude: ${longitude} °`;
  }

  function error() {
    status.textContent = 'Unable to retrieve your location';
  }

  if(!navigator.geolocation) {
    status.textContent = 'Geolocation is not supported by your browser';
  } else {
    status.textContent = 'Locating…';
    navigator.geolocation.getCurrentPosition(success, error);
  }

}

document.querySelector('#find-me').addEventListener('click', geoFindMe);
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Examples', 350, 150)}}</p>
